/* $Id: clut.inc,v 1.6 1998/11/24 18:45:20 marcus Exp $
******************************************************************************

   Generic CLUT manipulations

   Copyright (C) 1995		Steffen Seeger	[seeger@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

/*	DAC_PRECISION is the precision of the DAC who included this file.
*/
#if DAC_PRECISION == 6
	#define MAGIC	1040	/* 2^10 + 2^4 */
	#define	SHIFT	10
#endif

#if DAC_PRECISION == 8
	#define	MAGIC	257	/* 2^8 + 2^1 */
	#define	SHIFT	8
#endif

#ifndef MAGIC
	#error DAC_PRECISION not defined!
#endif

static void dac_set_clut(struct kgi_display *dpy, kgi_clut *clut,
			kgi_uint first, kgi_uint cnt)
{
	kgiu16 *data = (kgiu16 *) (clut->data + first);

	ASSERT(cnt);

	cnt += cnt + cnt;

	DAC_out8(dpy, first, DAC_PW_INDEX);
	while (cnt--) {

		DAC_out8(dpy, *(data++) >> SHIFT, DAC_P_DATA);
	}
}

static void dac_get_clut(struct kgi_display *dpy,
			 kgi_clut *clut, kgi_uint first, int cnt)
{
	kgiu16 *data = (kgiu16 *) (clut->data + first);

	cnt += cnt + cnt;

	DAC_out8(dpy, first, DAC_PR_INDEX);
	while (cnt--) {

		register kgiu16 col = DAC_in8(dpy, DAC_P_DATA);
		*(data++) = col*MAGIC;
	}
}
